import { IDataFrame } from '../dataframe';
/**
 * Compares to values and returns true if they are equivalent.
 */
export declare type ComparerFn<ValueT> = (a: ValueT, b: ValueT) => boolean;
export declare class DataFrameVariableWindowIterator<IndexT, ValueT> implements Iterator<IDataFrame<IndexT, ValueT>> {
    columnNames: Iterable<string>;
    iterator: Iterator<[IndexT, ValueT]>;
    nextValue: IteratorResult<[IndexT, ValueT]>;
    comparer: ComparerFn<ValueT>;
    constructor(columnNames: Iterable<string>, iterable: Iterable<[IndexT, ValueT]>, comparer: ComparerFn<ValueT>);
    next(): IteratorResult<IDataFrame<IndexT, ValueT>>;
}
