/**
 * A selector function with no index. Transforms a value into another kind of value.
 */
export declare type SelectorFnNoIndex<FromT, ToT> = (value: FromT) => ToT;
export declare class DistinctIterator<FromT, ToT> implements Iterator<FromT> {
    iterator: Iterator<FromT>;
    selector?: SelectorFnNoIndex<FromT, ToT>;
    valuesAlreadySeen: Set<any>;
    constructor(iterable: Iterable<FromT>, selector?: SelectorFnNoIndex<FromT, ToT>);
    next(): IteratorResult<FromT>;
}
